/***************************************************************************
 $RCSfile$
 -------------------
 cvs         : $Id: context_l.h 8 2005-09-23 18:55:21Z aquamaniac $
 begin       : Mon Mar 01 2004
 copyright   : (C) 2004 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/

#ifndef CTAPI_CHERRY_CONTEXT_L_H
#define CTAPI_CHERRY_CONTEXT_L_H


typedef struct CC_CONTEXT CC_CONTEXT;

CC_CONTEXT *CC_Context_new(unsigned short ctn,
			   unsigned short port);
void CC_Context_free(CC_CONTEXT *ctx);

unsigned short CC_Context_GetCtn(const CC_CONTEXT *ctx);
unsigned short CC_Context_GetPort(const CC_CONTEXT *ctx);

int CC_Context_HaveData(const CC_CONTEXT *ctx);
const unsigned char *CC_Context_GetDataPtr(const CC_CONTEXT *ctx);
unsigned int CC_Context_GetDataLen(const CC_CONTEXT *ctx);
void CC_Context_SetData(CC_CONTEXT *ctx,
                        const unsigned char *p,
                        unsigned int plen);

int CC_Context_GetReportAbsence(const CC_CONTEXT *ctx);
void CC_Context_SetReportAbsence(CC_CONTEXT *ctx, int i);


void CC_Context_Add(CC_CONTEXT **head, CC_CONTEXT *ctx);
void CC_Context_Del(CC_CONTEXT **head, CC_CONTEXT *ctx);
CC_CONTEXT *CC_Context_Next(const CC_CONTEXT *ctx);


#endif /* CTAPI_CHERRY_CONTEXT_L_H */
