/***************************************************************************
 $RCSfile$
 -------------------
 cvs         : $Id: ctapi-cherry.h 2 2005-06-14 16:18:36Z aquamaniac $
 begin       : Mon Mar 01 2004
 copyright   : (C) 2004 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifndef CTAPI_CHERRY_H
#define CTAPI_CHERRY_H


#define CC_AD_HOST		2
#define CC_AD_REMOTE	5

#define CC_AD_CT		1
#define CC_AD_ICC1		0
#define CC_AD_ICC2		2
#define CC_AD_ICC3		3
#define CC_AD_ICC4		4
#define CC_AD_ICC5		5
#define CC_AD_ICC6		6
#define CC_AD_ICC7		7
#define CC_AD_ICC8		8
#define CC_AD_ICC9		9
#define CC_AD_ICC10		10
#define CC_AD_ICC11		11
#define CC_AD_ICC12		12
#define CC_AD_ICC13		13
#define CC_AD_ICC14		14

#define CC_RV_OK		0
#define CC_RV_ERR_INVALID	-1
#define CC_RV_ERR_CT	        -8
#define CC_RV_ERR_TRANS	        -10
#define CC_RV_ERR_MEMORY	-11
#define CC_RV_ERR_HOST	        -127
#define CC_RV_ERR_HTSI	        -128

#define CC_CT			1
#define CC_HOST			2


char CT_init(unsigned short ctn, unsigned short pn);

char CT_data(unsigned short ctn,
             unsigned char *dad,
             unsigned char *sad,
             unsigned short lenc,
             unsigned char *command,
             unsigned short *lenr,
             unsigned char *response);

char CT_close(unsigned short ctn);

#endif /* CTAPI_CHERRY_H */

