/***************************************************************************
 $RCSfile$
 -------------------
 cvs         : $Id: kbd_handler_cherry_p.h 17 2005-11-29 18:26:56Z aquamaniac $
 begin       : Mon Mar 01 2004
 copyright   : (C) 2004 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/

#ifndef KBD_HANDLER_CHERRY_P_H
#define KBD_HANDLER_CHERRY_P_H

#include "kbd_handler_cherry.h"


typedef struct KBD_HANDLER_CHERRY KBD_HANDLER_CHERRY;
struct KBD_HANDLER_CHERRY {
  int fd;
  unsigned char buffer[KBD_HANDLER_MAXDATA];
  unsigned int bufsize;
};


static void kbd_handler_cherry_free(KBD_HANDLER *kh, void *p);
static int kbd_handler_cherry_init(KBD_HANDLER *kh);
static void kbd_handler_cherry_close(KBD_HANDLER *kh);
static int kbd_handler_cherry_handle(KBD_HANDLER *kh);
static int kbd_handler_cherry_get_card(KBD_HANDLER *kh,
                                       unsigned char *buffer,
                                       unsigned int *bufsize);






#endif

