/***************************************************************************
 $RCSfile$
 -------------------
 cvs         : $Id: kitest.c 17 2005-11-29 18:26:56Z aquamaniac $
 begin       : Mon Mar 01 2004
 copyright   : (C) 2004 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif


#include "kbd_handler.h"
#include "kbd_handler_cherry.h"

#include <stdio.h>
#include <linux/input.h>


int main(int argc, char **argv) {
  int rv=0;
  int i;
  KBD_HANDLER *kh;

  kh=kbd_handler_cherry_new();
  rv=kbd_handler_init(kh);
  if (rv) {
    fprintf(stderr, "ERROR: Could not init keyboard handler.\n");
    return 2;
  }

  for (i=0; i<2; i++) {
    rv=kbd_handler_handle(kh);
    if (rv && rv!=KBD_HANDLER_NO_CARD)
      break;
  }
  kbd_handler_close(kh);
  if (rv) {
    fprintf(stderr, "ERROR: Could not handle keyboard event.\n");
    return 2;
  }

  kbd_handler_free(kh);
  return 0;
}

